#gw 2.8.11 doesn't build otherwise:
%define Werror_cflags	%nil

%define oname wxGTK

%define major		0
%define api		2.8

%define	libnameu	%mklibname wxgtku %{api} %{major}
%define	libnameudev	%mklibname -d wxgtku %{api}
%define libglu		%mklibname wxgtkugl %{api} %{major}

Summary:	GTK+ port of the wxWidgets library
Name:		wxgtk%{api}
Version:	2.8.12
Release:	%mkrel 9
License:	wxWidgets Library Licence
Group:		System/Libraries
URL:		http://www.wxwidgets.org/
Source0:	http://prdownloads.sourceforge.net/wxwindows/%{oname}-%{version}.tar.bz2
#gw security patch for bundled expat which we don't use:
Patch2:		wxGTK-2.8.10-CVE-2009-XXXX.diff
Patch3:		wxgtk2.8-2.8.11-fix-linking.patch
Patch8:		wxWidgets-2.7.0-multiarch-includes.patch
#gw security patch for bundled expat which we don't use:
Patch9:		wxGTK-2.8.8-CVE-2009-3560.diff
BuildRequires:	jpeg-devel
BuildRequires:	tiff-devel
BuildRequires:	expat-devel
BuildRequires:	pkgconfig(cppunit)
BuildRequires:	pkgconfig(gconf-2.0)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(gstreamer-0.10)
BuildRequires:	pkgconfig(gstreamer-plugins-base-0.10)
BuildRequires:	pkgconfig(gtk+-2.0)
BuildRequires:	pkgconfig(libgnomeprintui-2.2)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(sdl)
BuildRequires:	pkgconfig(sm)
BuildRequires:	pkgconfig(xxf86vm)
BuildRequires:	pkgconfig(zlib)

%description
wxWidgets is a free C++ library for cross-platform GUI development.
With wxWidgets, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

%package -n %{libnameu}
Group:		System/Libraries
Summary:	Base shared library part of wxGTK - Unicode enabled
Requires:	%{name} = %{version}-%{release}
Obsoletes:	%{_lib}wxgtku2.8 < 2.8.12-5

%description -n %{libnameu}
wxWidgets is a free C++ library for cross-platform GUI development.
With wxWidgets, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

This package contains the library needed to run programs dynamically
linked with the unicode enabled version of %{name}.

%package -n %{libnameudev}
Summary:	Header files and development documentation for wxGTK - unicode
Group:		Development/C++
Requires:	%{libnameu} = %{version}-%{release}
Requires:	%{libglu} = %{version}-%{release}
Provides:	libwxgtku-devel = %{version}-%{release}
Provides:	libwxgtku%{api}-devel = %{version}-%{release}
Provides:	wxgtku-devel = %{version}-%{release}
Provides:	wxgtku%{api}-devel = %{version}-%{release}
Provides:	wxgtk-devel = %{version}-%{release}
Provides:	wxgtk%{api}-devel = %{version}-%{release}
Provides:	libwxgtk-devel = %{version}-%{release}
Provides:	libwxgtk%{api}-devel = %{version}-%{release}
Obsoletes:	%{_lib}wxgtk2.8-devel < 2.8.12-8

%description -n %{libnameudev}
Header files for the unicode enabled version of wxGTK, the GTK+ port of
the wxWidgets library.

%package  -n %{libglu}
Summary:	GTK+ port of the wxWidgets library, OpenGl add-on - unicode
Group:		System/Libraries
Obsoletes:	%{_lib}wxgtkglu2.8 < 2.8.12-5

%description -n %{libglu}
OpenGl add-on library for the unicode enabled version of wxGTK, the
GTK+ port of the wxWidgets library.

%prep
%setup -qn %{oname}-%{version}
%patch2 -p0 -b .CVE-2009-XXXX
%patch3 -p1 -b .linking
%patch8 -p1 -b .multiarch
%patch9 -p0 -b .CVE-2009-3560

# (fwang) Don't promote LDFLAGS in wx-config
sed -i -e 's/@LDFLAGS@//' -e 's/@WXCONFIG_CXXFLAGS@//' wx-config.in

# fix plugin dir for 64-bit
sed -i -e 's|/lib|/%{_lib}|' src/unix/stdpaths.cpp

find samples demos -name .cvsignore -exec rm {} \;

%build
# --disable-optimise prevents our $RPM_OPT_FLAGS being overridden
# (see OPTIMISE in configure).
# this code dereferences type-punned pointers like there's no tomorrow.
CFLAGS="%{optflags} -fno-strict-aliasing"
CXXFLAGS="%{optflags} -fno-strict-aliasing"

%configure2_5x --enable-unicode \
	--without-odbc \
  	--with-opengl \
	--enable-gtk2 \
	--with-gtk \
	--without-debug_flag \
  	--without-debug_info \
	--with-sdl \
  	--with-libpng=sys \
	--with-libjpeg=sys \
	--with-libtiff=sys \
	--with-zlib=sys \
	--with-expat=sys \
	--disable-optimise \
	--enable-calendar \
	--enable-wave \
	--enable-fraction \
	--enable-wxprintfv \
	--enable-xresources \
	--enable-controls \
	--enable-tabdialog \
	--enable-msgdlg \
	--enable-dirdlg \
	--enable-numberdlg \
	--enable-splash \
	--enable-textdlg \
	--enable-graphics_ctx \
	--enable-grid \
	--enable-catch_segvs \
	--enable-mediactrl \
	--enable-dataviewctrl \
	--enable-permissive \
	--disable-rpath

%make
# Why isn't this this part of the main build? Need to investigate.
%make -C locale allmo
%make -C contrib

#gw prepare samples
pushd demos
	make clean
	rm -f makefile* demos.bkl
popd

pushd samples
	make clean
	rm -f makefile* samples.bkl
popd

find demos samples -name Makefile|xargs perl -pi -e 's^CXXC =.*^CXXC=\$(CXX) `wx-config --cflags`^'
find demos samples -name Makefile|xargs perl -pi -e 's^EXTRALIBS =.*^EXTRALIBS=^'
find demos samples -name Makefile|xargs perl -pi -e 's^SAMPLES_RPATH_FLAG =.*^SAMPLES_RPATH_FLAG=^'

%install
%makeinstall_std
%makeinstall_std -C contrib

%find_lang wxstd --all-name

ln -sf ../..%{_libdir}/wx/config/gtk2-unicode-release-%{api} %{buildroot}%{_bindir}/wx-config
%multiarch_binaries %{buildroot}%{_bindir}/wx-config

%multiarch_includes %{buildroot}%{_includedir}/wx-%{api}/wx/defs.h

%pre -n %{libnameudev}
update-alternatives --remove-all wx-config

%files -f wxstd.lang
%defattr(-,root,root,-)
%doc *.txt

%files -n %{libnameu}
%defattr(-,root,root,-)
%{_libdir}/libwx_gtk2u_adv-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_aui-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_core-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_html-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_richtext-%{api}.so.%{major}*
%{_libdir}/libwx_baseu-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_media-%{api}.so.%{major}*
%{_libdir}/libwx_baseu_net-%{api}.so.%{major}*
%{_libdir}/libwx_baseu_xml-%{api}.so.%{major}*
# contribs
%{_libdir}/libwx_gtk2u_fl-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_gizmos-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_gizmos_xrc-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_ogl-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_plot-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_qa-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_stc-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_svg-%{api}.so.%{major}*
%{_libdir}/libwx_gtk2u_xrc-%{api}.so.%{major}*

%files -n %{libnameudev}
%defattr(-,root,root,-)
%doc samples/ docs/ demos/
%{_bindir}/wx-config
%{_bindir}/wxrc-%{api}
%{_bindir}/wxrc
%{multiarch_bindir}/wx-config
%{_includedir}/wx-%{api}/
%dir %{_libdir}/wx/
%dir %{_libdir}/wx/include/
%dir %{_libdir}/wx/include/gtk2-unicode-release-%{api}/
%dir %{_libdir}/wx/include/gtk2-unicode-release-%{api}/wx/
%dir %{_libdir}/wx/config
%{_libdir}/wx/config/gtk2-unicode-release-%{api}
%{_libdir}/wx/include/gtk2-unicode-release-%{api}/wx/setup.h
%{_libdir}/libwx_gtk2u_adv-%{api}.so
%{_libdir}/libwx_gtk2u_aui-%{api}.so
%{_libdir}/libwx_gtk2u_core-%{api}.so
%{_libdir}/libwx_gtk2u_html-%{api}.so
%{_libdir}/libwx_gtk2u_richtext-%{api}.so
%{_libdir}/libwx_baseu-%{api}.so
%{_libdir}/libwx_gtk2u_media-%{api}.so
%{_libdir}/libwx_baseu_net-%{api}.so
%{_libdir}/libwx_baseu_xml-%{api}.so
# contribs
%{_libdir}/libwx_gtk2u_fl-%{api}.so
%{_libdir}/libwx_gtk2u_gizmos-%{api}.so
%{_libdir}/libwx_gtk2u_gizmos_xrc-%{api}.so
%{_libdir}/libwx_gtk2u_ogl-%{api}.so
%{_libdir}/libwx_gtk2u_plot-%{api}.so
%{_libdir}/libwx_gtk2u_qa-%{api}.so
%{_libdir}/libwx_gtk2u_stc-%{api}.so
%{_libdir}/libwx_gtk2u_svg-%{api}.so
%{_libdir}/libwx_gtk2u_xrc-%{api}.so
#gl
%{_libdir}/libwx_gtk2u_gl-%{api}.so
%{_datadir}/aclocal/*
%{_datadir}/bakefile/
%{multiarch_includedir}/wx-%{api}/wx/defs.h

%files -n %{libglu}
%defattr(-,root,root,-)
%{_libdir}/libwx_gtk2u_gl-%{api}.so.%{major}*


%changelog

* Tue Jan 24 2012 fwang <fwang> 2.8.12-9.mga2
+ Revision: 200605
- move to correct section
- fix wrong symlink
- drop old packages
- only build unicode flavour
- cleanup messed up multiarch programs

* Fri Jan 20 2012 fwang <fwang> 2.8.12-7.mga2
+ Revision: 198660
- do not promote permissive in cnfig
- drop permissive build, as it is default to off by upstream

* Fri Dec 23 2011 fwang <fwang> 2.8.12-6.mga2
+ Revision: 186478
- rebuild for new libtiff

* Tue Dec 13 2011 wally <wally> 2.8.12-5.mga2
+ Revision: 181328
- fix lib names
- fix and clean provides
- clean .spec a bit
- update configure options to fix build and to build more libs
- drop old conflicts
- clean and sort BRs

* Sun Sep 11 2011 fwang <fwang> 2.8.12-4.mga2
+ Revision: 142256
- rebuild for new libpng

  + ahmad <ahmad>
    - Change the BR to pkgconfig BR style
    - Drop redundant BR libGConf2-devel
    - Don't promote LDFLAGS in wx-config (fwang)
    - Build with --enable-catch_segvs. The only pro I could find for disabling it
      is that it interferes with ABRT support[1], since we don't have ABRT support
      (either proper integration in the distro nor server side (bugzilla)) we can
      enable it for the time being. This should (fix mga#2232).
      [1] http://comments.gmane.org/gmane.linux.redhat.fedora.devel/135119

* Tue Jun 21 2011 ahmad <ahmad> 2.8.12-1.mga2
+ Revision: 111191
- Update to 2.8.12
- fix linking, and drop _disable_ld_no_undefined
- disable rpath for the unicode build too

* Fri Feb 25 2011 ahmad <ahmad> 2.8.11-4.mga1
+ Revision: 59942
- add more BR (Fedora)
- configure with --disable-rpath (Fedora)

* Sun Jan 16 2011 ahmad <ahmad> 2.8.11-3.mga1
+ Revision: 19943
- imported package wxgtk2.8

